#include "OkanWFMos.h"

using namespace std;

void OkanWFMos::giveWFMosaic( vector< IplImage* > images , vector<uchar**> masks , vector< double* > lines , double xRes , double yRes , IplImage * & retImage , uchar ** & retMask , double retLine[6] )
{
	// First x, second y
	double min[2], max[2];
	double x, y;
	min[0] = DBL_MAX;
	min[1] = DBL_MAX;
	max[0] = DBL_MIN;
	max[1] = DBL_MIN;
	//determine mins and maxs
	for( int i = 0 , size = images.size() ; i < size ; i++ )
	{
		RgbImage im( images[i] );
		calcXY( 0 , 0 , lines[i] , &x , &y );
		if ( x < min[0] )
			min[0] = x;
		if ( x > max[0] )
			max[0] = x;
		if ( y < min[1] )
			min[1] = y;
		if ( y > max[1] )
			max[1] = y;
		calcXY( images[i]->width - 1 , 0 , lines[i] , &x , &y );
		if ( x < min[0] )
			min[0] = x;
		if ( x > max[0] )
			max[0] = x;
		if ( y < min[1] )
			min[1] = y;
		if ( y > max[1] )
			max[1] = y;
		calcXY( 0 , images[i]->height - 1 , lines[i] , &x , &y );
		if ( x < min[0] )
			min[0] = x;
		if ( x > max[0] )
			max[0] = x;
		if ( y < min[1] )
			min[1] = y;
		if ( y > max[1] )
			max[1] = y;
		calcXY( images[i]->width - 1 , images[i]->height - 1 , lines[i] , &x , &y );
		if ( x < min[0] )
			min[0] = x;
		if ( x > max[0] )
			max[0] = x;
		if ( y < min[1] )
			min[1] = y;
		if ( y > max[1] )
			max[1] = y;
	}
	//Allocate memory for new image and mask
	int newWidth, newHeight;
	newWidth = (int) ( ( max[0] - min[0] ) / xRes );
	newHeight = (int) ( ( max[1] - min[1] ) / yRes );
	retImage = 	cvCreateImage( cvSize( newWidth , newHeight ) , IPL_DEPTH_8U , 3 );
	retMask = new uchar*[retImage->height];
	for ( int i = 0 , size = retImage->height ; i < size ; i++ )
		retMask[i] = new uchar[ retImage->width ];

	//Fill retLine
	retLine[0] = xRes;
	retLine[1] = 0;
	retLine[2] = 0;
	retLine[3] = -yRes;
	retLine[4] = min[0];
	retLine[5] = max[1];

	//Fill new image and mask
	int tmp, newX ,newY;
	RgbImage des( retImage );
	for ( int index = 0 , size = images.size() ; index < size ; index++ )
	{
		RgbImage src( images[index] );

		for ( int j = 0 ; j < images[index]->height ; j++ )
		{
			for ( int i = 0 ; i < images[index]->width ; i++ )
			{
				if ( masks[index] != NULL && masks[index][j][i] == 0 )
					continue;
				calcXY( i , j , lines[index] , &x , &y );
				tmp = (int) ( ( x - min[0] ) / xRes );
				if ( tmp  < 0 )
					newX = 0;
				else if ( tmp >= retImage->width )
					newX = retImage->width - 1;
				else
					newX = tmp;

				tmp = (int) ( ( max[1] - y ) / yRes );
				if ( tmp  < 0 )
					newY = 0;
				else if ( tmp >= retImage->height )
					newY = retImage->height - 1;
				else
					newY = tmp;

				des[newY][newX].b = src[j][i].b;
				des[newY][newX].g = src[j][i].g;
				des[newY][newX].r = src[j][i].r;
				retMask[newY][newX] = 1;
			}
		}
	}
}

void OkanWFMos::calcXY( int picX , int picY , double* line , double * x , double * y )
{
	*x = line[0] * picX + line[2] * picY + line[4];
	*y = line[1] * picX + line[3] * picY + line[5];
}
