#include <vector>
#include <string>
#include <string.h>
#include <iostream>

#ifdef LINUX
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/param.h>
#include <dlfcn.h>
#endif

#ifdef WIN32
#include <Windows.h>
#endif

#include "dL.h"

using namespace std;

///<todo>A windows counterpart should be written </todo>
#ifndef WIN32

static int fileSelect(struct direct const * entry) {
  char* ptr;

  if(!strcmp(entry->d_name, ".") ||
     !strcmp(entry->d_name, "..")) {
    return 0;
  }

  ptr = rindex(entry->d_name, '.');
  if(ptr && !strcmp(ptr, ".so"))
    return 1;

  return 0;
}

int matchesLib(const char* fileName, const char* funName) {
  void* handle;
  if(!(handle = dlopen((string("./") + string(fileName)).c_str(), RTLD_LAZY))) {
    cerr << "There is a problem with the shared library: " << fileName << endl;
    return 0;
  }
  
  if(dlsym(handle, funName))
    return 1;

  return 0;
}
vector<string>* getDynamicLibraries(string funName) {
  struct direct** files;
  int count;
  char wd[MAXPATHLEN];
  vector<string>* result = new vector<string>;

  if(!getwd(wd))
    cerr << "Can't get the working library" << endl ;
    
  count = scandir(wd, &files, fileSelect, alphasort);

  for(unsigned int i = 0; i < count; i++) {
    if(matchesLib(files[i]->d_name, funName.c_str()))
      result->push_back(string(files[i]->d_name));
  }
  return result;
}

#endif

#ifdef WIN32

int matchesLib(char* fName, string funName) {
   HINSTANCE dlf;
	 SetErrorMode(0);
   dlf = LoadLibrary(fName);
   if(dlf == NULL) {
     return 0;
   }

   void* funHandle = GetProcAddress(dlf, funName.c_str());
	 FreeLibrary(dlf);
   if(funHandle) {
		return 1;	
	 }
	 else {
		return 0;
	 }
}
vector<string>* getDynamicLibraries(string funName) {
  vector<string>* result = new vector<string>;
  unsigned int cdSize = GetCurrentDirectory(0, NULL);
  char* cd = new char[cdSize + 1];
  GetCurrentDirectory(cdSize + 1, cd);

  HANDLE hFind;
  WIN32_FIND_DATA fData;
  bool fresult = false;
  string fName = ((string(cd) + "\\" ) + "*.dll");
  hFind = FindFirstFile(fName.c_str(), &fData);
  if(hFind != INVALID_HANDLE_VALUE) {
     fresult = true;
  }

  while(fresult) {
    if(matchesLib(fData.cFileName, funName)) {
        result->push_back(string(fData.cFileName));
    }
    fresult = FindNextFile(hFind, &fData);
  }
  return result;
}
#endif

