#ifndef __MOSAICKERPANEL_H__
#define __MOSAICKERPANEL_H__

#include <iostream>

#include <wx/panel.h>
#include <wx/wx.h>
#include <wx/listctrl.h>

#ifdef LINUX
#include "../projectManager.h"
#include "../OkanReg.h"
#elif WIN32
#include "projectManager.h"
#endif

#ifdef WIN32

#ifdef HBMOSAICKERPLUGIN_EXPORTS
#define PLUGIN_API __declspec(dllexport)
#else
#define PLUGIN_API __declspec(dllimport)
#endif

#ifdef __cplusplus    // If used by C++ code, 
extern "C"          // we need to export the C interface
#endif
PLUGIN_API void __cdecl plugMosaicker(wxWindow*, ProjectManager* pm);

#ifdef __cplusplus    // If used by C++ code, 
extern "C"          // we need to export the C interface
#endif
PLUGIN_API wxSize __cdecl negotiateSize();

#elif LINUX

extern "C" void plugMosaicker(wxWindow*, ProjectManager* pm);
extern "C" wxSize negotiateSize();

#endif


using namespace std;

#define xsize 250
#define ysize 400

class MosaickerPanel : public wxPanel {
  protected:
  DECLARE_EVENT_TABLE()
  private:
  enum {
    IdStartCtrl = wxID_HIGHEST + 1,
    IdNCorners,
    IdCornerQualityLevel,
    IdMinCornerDistance,
    IdBlockSize,
    IdApertureSize,
    IdCornerWindowSize,
    IdMaxDistance, 
    IdThresholdValue,
    IdNIterations,
    IdErrorTolerance,
    IdIPList,
    IdRDialog,
    IdSDialog

  };
  double cornerQLevel, minCornerDistance, blockSize, aptSize, cornerWinSize, maxDistance, thresh, errTol;
  long nCorners, nIter;
  ProjectManager* pm;
  wxListCtrl* imListCtrl;
  OkanReg reg;
 public:
  //MosaickerWindow();
  MosaickerPanel(ProjectManager* pm, wxWindow* parent, wxWindowID id = wxID_ANY, wxPoint pos = wxDefaultPosition, wxSize size = wxSize(xsize, ysize), long style = wxTAB_TRAVERSAL);

  void Init();

  //bool Create(wxWindow*, wxWindowID, wxString, wxPoint, wxSize, long);

  void CreateControls();
  void onStartMosaic(wxCommandEvent&);
  
  bool TransferDataFromWindow();
  bool TransferDataToWindow();

  void onPaneClick(wxMouseEvent&);
};

#endif
