#include <string>

#include "historyChaser.h"

using namespace std;

int HistoryChaser::pushProjectRename(string oldName, string newName) {
  HistoryElement elem;
  elem.oldName = oldName;
  elem.newName = newName;
  elem.actionType = AcProjectRename;
  historyElements.push_back(elem);
  return 1;
}

int HistoryChaser::popProjectRename(HistoryElement& elem) {
  Meta* projectData = project->getMetaData();
  projectData->setName(elem.oldName);
  project->setMetaData(projectData);
  return 1;
}

int HistoryChaser::popHistory() {
  if(!pos)
    return 0;

  HistoryElement lastAc = historyElements.back();
  int result = 0x7FFF;

  switch(lastAc.actionType) {
  case AcProjectRename:
    result = popProjectRename(lastAc);
    break;
  } 
  assert(result != 0x7FFF);

  if(result == 1)
    pos -= 1;
  
  return 1;
}
