#include "imageFactory.h"

Image* ImageFactory::createImage(int width, int height, int bpp, string name) {
  Image* newImage = new Image(name, "", "", "");
  ImageHandle* newHandle = new ImageHandle();
  
  newHandle->width = width;
  newHandle->height = height;
  newHandle->bpp = bpp;
  newHandle->imagePath = "";
  //bpp is useless
  newHandle->rawData = new unsigned char[width * height * 3];
  newHandle->origData = NULL;  //new unsigned char[width * height * 3];
  newHandle->dataset = NULL;

  newImage->imHandle = newHandle;
  newImage->assocCamera = "";

  return newImage;
}

Image* ImageFactory::fromIplHandle(IplImage* iplHandle, string name) {
  Image* newImage = createImage(iplHandle->width, iplHandle->height, 3, name);
  unsigned char* data;
  unsigned char* data2 = newImage->imHandle->rawData;
  unsigned char* data3 = newImage->imHandle->origData;
  int step;

  CvSize size;
  int x, y;

  cvGetRawData( iplHandle, &data, &step, &size );
  step /= sizeof(data[0]);
  int i = 0;
  for( i = 0, y = 0; y < size.height; y++, data += step )
    for( x = 0; x < size.width; x++ ) {
      data2[i] = data[3 * x + 2];
      data2[i + 1] = data[3 * x + 1];
      data2[i + 2] = data[3 * x];   

      i += 3;
    }
  //delete[] data;
  return newImage;
}
