#ifndef __IMAGEPROCESSORWINDOW_H__
#define __IMAGEPROCESSORWINDOW_H__
#include <wx/wx.h>

#include "projectManagerWindow.h"
#include "projectManager.h"

class ProjectManagerWindow;

class ImageProcessorWindow : public wxPanel {
 protected:
  DECLARE_EVENT_TABLE()
 private:
  enum {
    IdContrast = wxID_HIGHEST + 1,
    IdBrightness,
    IdConvolution,
    IdZoomIn,
    IdZoomOut,
    IdRotateRight,
    IdRotateLeft,
    IdHistEq
  };


 public:
  ProjectManagerWindow* pmw;
  ProjectManager* pm;
  ImageProcessorWindow(ProjectManagerWindow*, wxWindow*, wxWindowID);
  
  void onBrightness(wxScrollEvent&);
  void onHistEq(wxCommandEvent&);
  void onFilter(wxCommandEvent&);
  void onZoomIn(wxCommandEvent&);
  void onZoomOut(wxCommandEvent&);
  void onRotateRight(wxCommandEvent&);
  void onRotateLeft(wxCommandEvent&);
  void setSliders(int);
};
#endif
