#include <wx/wx.h>
#include <string>

#include "newProjectDialog.h"

using namespace std;

NewProjectDialog::NewProjectDialog() {

}

NewProjectDialog::NewProjectDialog(wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style) : wxDialog(parent, id, caption, pos, size, style) {
  Create(parent, id, caption, pos, size, style);
}

void NewProjectDialog::Create(wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style) {
  wxBoxSizer* outSizer = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* topSizer = new wxBoxSizer(wxVERTICAL);

  this->SetSizer(outSizer);
  outSizer->Add(topSizer, 0, wxALIGN_CENTER_HORIZONTAL | wxEXPAND | wxALL, 5);
  wxStaticText* newProjectText = new wxStaticText(this, wxID_STATIC, _("&Project Name: "), wxDefaultPosition, wxDefaultSize, 0);

  topSizer->Add(newProjectText, 0, wxALIGN_LEFT | wxALL, 5);

  wxTextCtrl* newProjectNameCtrl = new wxTextCtrl(this, IdNewProjectNameCtrl, _("Project"), wxDefaultPosition, wxDefaultSize, 0);

  topSizer->Add(newProjectNameCtrl, 0, wxALIGN_LEFT | wxGROW | wxALL, 5);

  wxStaticText* newProjectPathText = new wxStaticText(this, wxID_STATIC, _("&Project Path: "), wxDefaultPosition, wxDefaultSize, 0);

  topSizer->Add(newProjectPathText, 0, wxALIGN_LEFT | wxALL, 5);

  wxTextCtrl* newProjectPathCtrl = new wxTextCtrl(this, IdNewProjectPathCtrl, _("Project path"), wxDefaultPosition, wxDefaultSize, 0);

  topSizer->Add(newProjectPathCtrl, 0, wxGROW | wxALL, 5);

  wxStaticText* newProjectDescText = new wxStaticText(this, wxID_STATIC, _("&Project Description: "), wxDefaultPosition, wxDefaultSize, 0);

  topSizer->Add(newProjectDescText, 0, wxALIGN_LEFT | wxALL, 5);

  wxTextCtrl* newProjectDescCtrl = new wxTextCtrl(this, IdNewProjectDescCtrl, _("Project description"), wxDefaultPosition, wxDefaultSize, 0);

  topSizer->Add(newProjectDescCtrl, 0, wxGROW | wxALL, 5);

  wxBoxSizer* buttonSizer = new wxBoxSizer(wxHORIZONTAL);
  topSizer->Add(buttonSizer, 0, wxALIGN_CENTER_HORIZONTAL | wxALL, 2);

  wxButton* okButton = new wxButton(this, wxID_OK, _("&Next"), wxDefaultPosition, wxDefaultSize, 0);
  buttonSizer->Add(okButton, 0, wxALIGN_CENTER_VERTICAL | wxALL, 3);

  wxButton* cancelButton = new wxButton(this, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0);
  buttonSizer->Add(cancelButton, 0, wxALIGN_CENTER_VERTICAL | wxALL, 3);
 
  FindWindow(IdNewProjectNameCtrl)->SetValidator(wxTextValidator(wxFILTER_ALPHA, &projectName));
  FindWindow(IdNewProjectPathCtrl)->SetValidator(wxTextValidator(wxFILTER_ASCII, &projectPath));
  FindWindow(IdNewProjectDescCtrl)->SetValidator(wxTextValidator(wxFILTER_ALPHANUMERIC, &projectDescription));

}
