#ifndef __PROJECTPRESENTER_H__
#define __PROJECTPRESENTER_H__
#include <string>
#include <vector>
#include <utility>
#include <map>

#include "project.h"
#include "content.h"

using namespace std;

///<summary>Information about a Project class instance can be obtained
///from ProjectPresenter. This prevents direct exposure of Project
///class to the ProjectManagerWindow.</summary>
class ProjectPresenter {
 public:
  Project* project;
  int attachProject(Project*);
 public:
  string getProjectName();
  string getProjectAddress() {
    return project->address;
  }
  vector<pair<string, ContentType> >* enumerateContents();
  map<string, Content*>* getContentsByName() {
    return project->contentsByName;
  }
};

#endif
