#include "OkanOrto.h"

#include "highgui.h"

#include <iostream>
#include <fstream>
#include <vector>
#include <string>
using namespace std;

OkanOrto orto;
IplImage* image1, *image2, *image3;

int main()
{

	string im1 = "data/image1.jpg";

	image1 = cvLoadImage( im1.c_str() , 1 );
	OkanImageParam imageParam1( 28 , 9 , 0 , 0 , -1.229528 , 6.844284 , -97.622549 , 599021.176 , 4159556.405 , 1851.948 );
	

	string im2 = "data/image2.jpg";

	image2 = cvLoadImage( im2.c_str() , 1 );
	OkanImageParam imageParam2( 28 , 9 , 0 , 0 , -0.116640 , 6.018895 , -98.067556 , 598859.134 , 4159579.441 , 1853.994 );


	string im3 = "data/image3.jpg";

	image3 = cvLoadImage( im3.c_str() , 1 );
	OkanImageParam imageParam3( 28 , 9 , 0 , 0 , 0.145811 , 4.769086 , -95.931765 , 598688.036 , 4159584.978 , 1853.561 );

	double averageHeight = 0;

	double **dem = new double*[image1->height];
	for( int i = 0 ; i < image1->height ; i++ )
		dem[i] = new double[image1->width];
	for( int j = 0 ; j < image1->height ; j++ )
		for( int i = 0 ; i < image1->width ; i++ )
			dem[j][i] = 605;
	
	orto.setImage( image1 , NULL , imageParam1 , averageHeight , dem );
	orto.setImage( image2 , NULL , imageParam2 , averageHeight , dem );
	orto.setImage( image3 , NULL , imageParam3 , averageHeight , dem );
	double line[6];
	IplImage * result;
	uchar **outputMask;
	orto.giveOrtoImageByPixelSize( result , outputMask , line , 1 , 1 );

	for( int i = 0 ; i < 6 ; i++ )
		cout << line[i] << endl;

	IplImage * resultMask;
	resultMask = cvCreateImage( cvSize( result->width , result->height ) , IPL_DEPTH_8U , 3 );
	RgbImage mask( resultMask );
	for( int j = 0 ; j < result->height ; j++ )
	{
		for( int i = 0 ; i < result->width ; i++ )
		{
			if ( outputMask[j][i] == 0 )
			{
				mask[j][i].b = 0;
				mask[j][i].g = 0;
				mask[j][i].r = 0;
			}
			else
			{
				mask[j][i].b = 255;
				mask[j][i].g = 255;
				mask[j][i].r = 255;
			}
		}
	}
	cvNamedWindow( "result", 1 );
	cvShowImage( "result", result );
	cvWaitKey(0);
	cvSaveImage( "result1.jpg" , result );
	cvSaveImage( "resultMask1.jpg" , resultMask );
	ofstream out("result1.jgw");
	char buffer[20];
	for ( int i = 0 ; i < 6 ; i++ )
	{
		sprintf( buffer , "%lf\n" , line[i] );
		out << buffer;
		cout << buffer;
	}
	out.close();
}


